/* tslint:disable */
/* eslint-disable */
/* prettier-ignore */
// This document is generated by rokot-apicontroller-client-generator. DO NOT edit directly.

export interface HeaderMap {
    [k: string]: string;
}

export interface IFetcher {
    request<T>(url: string, verb: string, contentType: string, body?: any, headers?: HeaderMap): Promise<T>;
    buildQueryString(query?: any): string;
    requestValidate?(routeUniqueName: string, paramValues: {
        body?: any;
        params?: any;
        query?: any;
    }): Promise<void>;
}

export class BaseClass {
    kind: string;
}

export interface IUpdatedOn {
    updatedOn: string;
}

export interface IUpdatable extends IUpdatedOn {
    updatedBy: string;
}

export class Profile extends BaseClass implements IUpdatable {
    profile: any;
    updatedBy: string;
    updatedOn: string;
}

export class TestController {
    constructor(private fetcher: IFetcher) { }
    getAll = (headers?: HeaderMap): Promise<Profile> => {
        return this.fetcher.request<Profile>(`test/all`, "get", "application/json", undefined, headers);
    };
}

export class ApiClient {
    constructor(private fetcher: IFetcher) { }
    test = new TestController(this.fetcher);
}